if not Recount then return end

local Recount = Recount

local RecountChogallCC = CreateFrame("Frame")
RecountChogallCC.Version = tonumber(string.sub("$Revision: 1 $", 12, -3))
local addon = RecountChogallCC

local RL = LibStub("AceLocale-3.0"):GetLocale("Recount")
local L = LibStub("AceLocale-3.0"):GetLocale("RecountChogallCC")

-------------------------------------------------------------------------
-- LOCALES
-------------------------------------------------------------------------

local DetailTitles={}
DetailTitles.CCdHow={
	TopNames = RL["Ability Name"],
	TopCount = "",
	TopAmount = RL["Count"],
	BotNames = "",
	BotMin = "",
	BotAvg = "",
	BotMax = "",
	BotAmount = RL["Count"]
}

local worshipping = {}
local CCeffects = {
	-- general
	28730, -- arcane torrent
	-- Priest
	8122, -- phsycic scream
	64044, -- psychic horror
	15487, -- silence
	-- Hunter
	19503, -- scatter shot
	19386, -- wyvern sting
	-- Druid
	5211, -- bash
	22570, -- maim
	33786, -- cyclone
	80964, -- skull bash -- bear
	80965, -- skull bash -- cat
	78675, -- solar beam -- not sure if this is the righ spellId
	-- Paladin
	85285, -- rebuke
	853, -- hammer of justice
	31935, -- avenger's shield
	-- Warrior
	57755, -- heroic throw
	12809, -- concussion blow
	46968, -- shockwave
	7922, -- charge stun
	20252, -- intercept
	72, -- shield bash
	6552, -- pummel
	5246, -- intimidating shout
	6544, -- heroic leap
	-- Mage
	31661, -- dragon's breath
	2139, -- counterspell
--polymorph
	118,
	61305,
	28272,
	61721,
	61780,
	28271,
	-- Rogue
	2094, -- blind
	408, -- kidney shot
	1833, -- cheap shot
	1776, -- gouge
	1766, -- kick
	6770, -- sap
	-- Death Knight
	49576, -- death grip
	47528, -- mind freeze
	47476, -- strangulate
	-- Shaman
	51514, -- hex
	57994, -- wind shear
	-- Warlock
	5782, -- fear
	6789, -- deat hcoil
	5484, -- howl of terror
	54785, -- demon leap

}

local function CCused(spellId)
	for i, v in ipairs(CCeffects) do
		if spellId == v then
			return true
		end
	end
	return false
end

-------------------------------------------------------------------------
-- UTILITY
-------------------------------------------------------------------------

function addon:IncreaseData(sourceName, spellId)
	if not Recount.db2.combatants[sourceName] then
		Recount:DPrint("No source combatant!")
	else
		local sourceData=Recount.db2.combatants[sourceName]
		local name = sourceData.Name
		Recount:AddAmount(sourceData,"CCs",1)
		local spell = GetSpellInfo(spellId) or ""
		Recount:AddTableDataStats(sourceData,"CCdHow",spell,name,1)
	end
end

function addon:CombatLog(event, ...)
	local timestamp, type, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags = ...
	if type == "SPELL_INTERRUPT" then
		local spellId, _, _, interruptedSpell = select(9, ...)
		if (interruptedSpell == 91317 or interruptedSpell == 93366 or interruptedSpell == 93365) and worshipping[destName] then
			worshipping[destName] = false
			addon:IncreaseData(sourceName, spellId)
		end
	elseif type == "SPELL_AURA_APPLIED" then
		local spellId = select(9, ...)
		if spellId == 91317 or spellId == 93366 or spellId == 93365 then
			worshipping[sourceName] = true
		elseif CCused(spellId) and worshipping[destName] then
			worshipping[destName] = false
			addon:IncreaseData(sourceName, spellId)
		end
	elseif type == "SPELL_AURA_REMOVED" then
		local spellId = select(9, ...)
		if spellId == 91317 or spellId == 93366 or spellId == 93365 then
			worshipping[sourceName] = false
		end
	elseif type == "SPELL_CAST_SUCCESS" then -- might result some false positives
		local spellId = select(9,...)
		if CCused(spellId) and destName and worshipping[destName] then
			worshipping[destName] = false
			addon:IncreaseData(sourceName, spellId)
		end
	end
end

function addon:DataModesChogallCC(data, num)
	if not data then return 0 end
	if num==1 then
		return (data.Fights[Recount.db.profile.CurDataSet].CCs or 0)
	else
		return (data.Fights[Recount.db.profile.CurDataSet].CCs or 0), {{data.Fights[Recount.db.profile.CurDataSet].CCdHow,L["'s interrupts"],DetailTitles.CCdHow}}
	end
end

function addon:TooltipFuncsChogallCC(name, data)
	GameTooltip:ClearLines()
	GameTooltip:AddLine(name)
	Recount:AddSortedTooltipData(RL["Top 3"].." "..L["Worship interrupts"],data and data.Fights[Recount.db.profile.CurDataSet] and data.Fights[Recount.db.profile.CurDataSet].CCdHow,3)
	GameTooltip:AddLine("<"..RL["Click for more Details"]..">",0,0.9,0)
end

Recount:AddModeTooltip(L["Worship interrupts"],RecountChogallCC.DataModesChogallCC,RecountChogallCC.TooltipFuncsChogallCC,nil,nil,nil,nil)

-------------------------------------------------------------------------
-- EVENT HANDLER
-------------------------------------------------------------------------

local function detectInstanceChange()
	SetMapToCurrentZone()
	local zone = GetRealZoneText()
	if zone == nil or zone == "" then
		-- zone hasn't been loaded yet, try again in 5 secs.
		addon:ScheduleTimer(detectInstanceChange, 5)
		return
	elseif GetCurrentMapAreaID() == 758 then
		addon:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	else
		addon:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	end
end

addon:RegisterEvent("ZONE_CHANGED_NEW_AREA")
addon:RegisterEvent("ADDON_LOADED")
addon:SetScript("OnEvent", function(self, event, ...)
	if event == "ADDON_LOADED" and (select(1,...)) == "RecountChogallCC" then
		LibStub("AceTimer-3.0"):Embed(addon)
		detectInstanceChange()
		self:UnregisterEvent("ADDON_LOADED")
	elseif event == "ZONE_CHANGED_NEW_AREA" then
		detectInstanceChange()
	elseif event == "COMBAT_LOG_EVENT_UNFILTERED" then
		addon:CombatLog(event, ...)
	end
end)
